package net.mcreator.enchantsandthings.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.enchantsandthings.world.inventory.DimentionRingGUIMenu;
import net.mcreator.enchantsandthings.network.DimentionRingGUIButtonMessage;
import net.mcreator.enchantsandthings.EnchantsAndThingsMod;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class DimentionRingGUIScreen extends AbstractContainerScreen<DimentionRingGUIMenu> {
	private final static HashMap<String, Object> guistate = DimentionRingGUIMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Button button_overworld;
	Button button_nether_button;
	Button button_end;

	public DimentionRingGUIScreen(DimentionRingGUIMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 166;
	}

	private static final ResourceLocation texture = new ResourceLocation("enchants_and_things:textures/screens/dimention_ring_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.enchants_and_things.dimention_ring_gui.label_which_dimention"), 51, 16, -16342264, false);
	}

	@Override
	public void init() {
		super.init();
		button_overworld = Button.builder(Component.translatable("gui.enchants_and_things.dimention_ring_gui.button_overworld"), e -> {
			if (true) {
				EnchantsAndThingsMod.PACKET_HANDLER.sendToServer(new DimentionRingGUIButtonMessage(0, x, y, z));
				DimentionRingGUIButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 51, this.topPos + 52, 72, 20).build();
		guistate.put("button:button_overworld", button_overworld);
		this.addRenderableWidget(button_overworld);
		button_nether_button = Button.builder(Component.translatable("gui.enchants_and_things.dimention_ring_gui.button_nether_button"), e -> {
			if (true) {
				EnchantsAndThingsMod.PACKET_HANDLER.sendToServer(new DimentionRingGUIButtonMessage(1, x, y, z));
				DimentionRingGUIButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		}).bounds(this.leftPos + 42, this.topPos + 88, 93, 20).build();
		guistate.put("button:button_nether_button", button_nether_button);
		this.addRenderableWidget(button_nether_button);
		button_end = Button.builder(Component.translatable("gui.enchants_and_things.dimention_ring_gui.button_end"), e -> {
			if (true) {
				EnchantsAndThingsMod.PACKET_HANDLER.sendToServer(new DimentionRingGUIButtonMessage(2, x, y, z));
				DimentionRingGUIButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		}).bounds(this.leftPos + 51, this.topPos + 124, 72, 20).build();
		guistate.put("button:button_end", button_end);
		this.addRenderableWidget(button_end);
	}
}
