
package net.mcreator.enchantsandthings.network;

import net.minecraftforge.network.NetworkEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.core.BlockPos;

import net.mcreator.enchantsandthings.world.inventory.DimentionRingGUIMenu;
import net.mcreator.enchantsandthings.procedures.OverworldButtonProcedure;
import net.mcreator.enchantsandthings.procedures.NetherbuttonProcedure;
import net.mcreator.enchantsandthings.procedures.EndButtonProcedure;
import net.mcreator.enchantsandthings.EnchantsAndThingsMod;

import java.util.function.Supplier;
import java.util.HashMap;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class DimentionRingGUIButtonMessage {
	private final int buttonID, x, y, z;

	public DimentionRingGUIButtonMessage(FriendlyByteBuf buffer) {
		this.buttonID = buffer.readInt();
		this.x = buffer.readInt();
		this.y = buffer.readInt();
		this.z = buffer.readInt();
	}

	public DimentionRingGUIButtonMessage(int buttonID, int x, int y, int z) {
		this.buttonID = buttonID;
		this.x = x;
		this.y = y;
		this.z = z;
	}

	public static void buffer(DimentionRingGUIButtonMessage message, FriendlyByteBuf buffer) {
		buffer.writeInt(message.buttonID);
		buffer.writeInt(message.x);
		buffer.writeInt(message.y);
		buffer.writeInt(message.z);
	}

	public static void handler(DimentionRingGUIButtonMessage message, Supplier<NetworkEvent.Context> contextSupplier) {
		NetworkEvent.Context context = contextSupplier.get();
		context.enqueueWork(() -> {
			Player entity = context.getSender();
			int buttonID = message.buttonID;
			int x = message.x;
			int y = message.y;
			int z = message.z;
			handleButtonAction(entity, buttonID, x, y, z);
		});
		context.setPacketHandled(true);
	}

	public static void handleButtonAction(Player entity, int buttonID, int x, int y, int z) {
		Level world = entity.level();
		HashMap guistate = DimentionRingGUIMenu.guistate;
		// security measure to prevent arbitrary chunk generation
		if (!world.hasChunkAt(new BlockPos(x, y, z)))
			return;
		if (buttonID == 0) {

			OverworldButtonProcedure.execute(entity);
		}
		if (buttonID == 1) {

			NetherbuttonProcedure.execute(entity);
		}
		if (buttonID == 2) {

			EndButtonProcedure.execute(world, entity);
		}
	}

	@SubscribeEvent
	public static void registerMessage(FMLCommonSetupEvent event) {
		EnchantsAndThingsMod.addNetworkMessage(DimentionRingGUIButtonMessage.class, DimentionRingGUIButtonMessage::buffer, DimentionRingGUIButtonMessage::new, DimentionRingGUIButtonMessage::handler);
	}
}
